# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# dirac::StreamPicInput Class Reference

Picture input class. More...

`#include <pic_io.h>`

Inheritance diagram for dirac::StreamPicInput:

[legend]
Collaboration diagram for dirac::StreamPicInput:

[legend]

List of all members.

## Public Member Functions

- StreamPicInput ()
    Default Constructor.
- StreamPicInput (std::istream *ip_pic_ptr, const SeqParams &sparams)
    Constructor.
- virtual ~StreamPicInput ()
    Destructor.
- virtual void Skip (const int n)=0
    Skip n frames of input.
- void SetPadding (const int xpd, const int ypd)
    Set padding values to take into account block and transform sizes.
- virtual bool ReadNextFrame (Frame &myframe)
    Read the next frame from the file.
- SeqParams & GetSeqParams () const
    Get the sequence parameters.
- bool End () const
    Returns true if we're at the end of the input, false otherwise.

## Protected Member Functions

- virtual bool ReadComponent (PicArray &pic_data, const CompSort &cs)
    Read a component from the file.

## Protected Attributes

- SeqParams m_sparams
    Sequence parameters.
- std::istream * m_ip_pic_ptr
    Input stream.
- int m_xpad
    padding values
- int m_ypad

## Detailed Description

Abstract Class for reading picture data from a stream.

## Constructor & Destructor Documentation

dirac::StreamPicInput::StreamPicInput | ( |  | ) |

dirac::StreamPicInput::StreamPicInput | ( | std::istream * | ip_pic_ptr,
|  | const SeqParams & | sparams |
| ) |  |  |

Constructor, takes

Parameters:

  | ip_pic_ptr | input stream to read from
  | sparams | Sequence parameters

virtual dirac::StreamPicInput::~StreamPicInput | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual void dirac::StreamPicInput::Skip | ( | const int | n | ) | `[pure virtual]`

Implemented in dirac::MemoryStreamInput, and dirac::FileStreamInput.

void dirac::StreamPicInput::SetPadding | ( | const int | xpd,
|  | const int | ypd |
| ) |  |  |

virtual bool dirac::StreamPicInput::ReadNextFrame | ( | Frame & | myframe | ) | `[virtual]`

SeqParams& dirac::StreamPicInput::GetSeqParams | ( |  | ) | const`[inline]`

References m_sparams.

bool dirac::StreamPicInput::End | ( |  | ) | const

Reimplemented in dirac::MemoryStreamInput.

virtual bool dirac::StreamPicInput::ReadComponent | ( | PicArray & | pic_data,
|  | const CompSort & | cs |
| ) |  |  | `[protected, virtual]`

## Member Data Documentation

SeqParams dirac::StreamPicInput::m_sparams `[mutable, protected]`

Referenced by GetSeqParams(), and dirac::MemoryStreamInput::SetSequenceParams().

std::istream* dirac::StreamPicInput::m_ip_pic_ptr `[protected]`

int dirac::StreamPicInput::m_xpad `[protected]`

int dirac::StreamPicInput::m_ypad `[protected]`

The documentation for this class was generated from the following file:

- pic_io.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.